! ===========================================================================
!   Inform Language Definition File: French
!
!   (c) Graham Nelson 1997
!   (c) Jean-Luc Pontico 2001-2002 (traduction franaise)
!  (Certaines fonctions sont tires de la librairie en espagnol de Jose Luis Diaz.)
! ---------------------------------------------------------------------------
System_file;
! ---------------------------------------------------------------------------
!   Part I.   Preliminaries
! ---------------------------------------------------------------------------
Constant LanguageVersion = "Traduction franaise";

! lignes dsactives car sinon Zplet n'affiche pas bien certains accents
!Zcharacter '';
!Zcharacter '';
!Zcharacter '';
!Zcharacter '';
!Zcharacter '';
!Zcharacter '';

Class  CompassDirection
  with article "le", number 0
  has  scenery;
Object Compass "compas" has concealed;
IFNDEF WITHOUT_DIRECTIONS;
CompassDirection -> n_obj "nord"
                    with name 'n//' 'nord' 'mur',    door_dir n_to;
CompassDirection -> s_obj "sud"
                    with name 's//' 'sud' 'mur',    door_dir s_to;
CompassDirection -> e_obj "est"
                    with name 'e//' 'est' 'mur',     door_dir e_to;
CompassDirection -> w_obj "ouest"
                    with name 'o//' 'ouest' 'mur',  door_dir w_to;
CompassDirection -> ne_obj "nord-est"
                    with name 'ne' 'nordest' 'mur', door_dir ne_to;
CompassDirection -> nw_obj "nord-ouest"
                    with name 'no' 'nordouest' 'mur', door_dir nw_to;
CompassDirection -> se_obj "sud-est"
                    with name 'se' 'sudest' 'mur', door_dir se_to;
CompassDirection -> sw_obj "sud-ouest"
                    with name 'so' 'sudouest' 'mur', door_dir sw_to;
CompassDirection -> u_obj "haut"
                    with name 'h//' 'haut' 'plafond',    door_dir u_to;
CompassDirection -> d_obj "bas"
                    with name 'b//' 'd//' 'bas' 'sol',    door_dir d_to;
ENDIF;
CompassDirection -> out_obj "l'extrieur"
                    with name 'dehors' 'exterieur',        door_dir out_to,
                    has proper;
CompassDirection -> in_obj "l'intrieur"
                    with name 'dedans' 'interieur',        door_dir in_to,
                    has proper;
! ---------------------------------------------------------------------------
!   Part II.   Vocabulary
! ---------------------------------------------------------------------------
Constant AGAIN1__WD   = 'encore';
Constant AGAIN2__WD   = 'g//';
Constant AGAIN3__WD   = 'c//';
Constant OOPS1__WD    = 'oops';
Constant OOPS2__WD    = 'euh';
Constant OOPS3__WD    = 'euh';
Constant UNDO1__WD    = 'undo';
Constant UNDO2__WD    = 'annule';
Constant UNDO3__WD    = 'annuler';

Constant ALL1__WD     = 'tous';
Constant ALL2__WD     = 'toutes';
Constant ALL3__WD     = 'tout';
Constant ALL4__WD     = 'tout';
Constant ALL5__WD     = 'tout';
Constant AND1__WD     = 'et';
Constant AND2__WD     = 'et';
Constant AND3__WD     = 'et';
Constant BUT1__WD     = 'mais pas';
Constant BUT2__WD     = 'excepte';
Constant BUT3__WD     = 'sauf';
Constant ME1__WD      = 'moi';
Constant ME2__WD      = 'moimeme';
Constant ME3__WD      = 'moi';
Constant OF1__WD      = 'de';
Constant OF2__WD      = 'de';
Constant OF3__WD      = 'de';
Constant OF4__WD      = 'de';
Constant OTHER1__WD   = 'unautre';
Constant OTHER2__WD   = 'autre';
Constant OTHER3__WD   = 'autre';
Constant THEN1__WD    = 'alors';
Constant THEN2__WD    = 'puis';
Constant THEN3__WD    = 'ensuite';

Constant NO1__WD      = 'n//';
Constant NO2__WD      = 'non';
Constant NO3__WD      = 'non';
Constant YES1__WD     = 'o//';
Constant YES2__WD     = 'y//';
Constant YES3__WD     = 'oui';

Constant AMUSING__WD  = 'amusing';
Constant FULLSCORE1__WD = 'fullscore';
Constant FULLSCORE2__WD = 'full';
Constant QUIT1__WD    = 'q//';
Constant QUIT2__WD    = 'quitter';
Constant RESTART__WD  = 'recommencer';
Constant RESTORE__WD  = 'charger';

Array LanguagePronouns table

   !  word       possible GNAs                   connected
   !             to follow:                      to:
   !             a     i
   !             s  p  s  p
   !             mfnmfnmfnmfn                 

      ! Object pronouns
      '-le'    $$100000100000                    NULL
      '-la'    $$010000010000                    NULL
      '-les'   $$000110000110                    NULL
      '-lui'   $$110000110000                    NULL
      '-leur'  $$000110000110                    NULL
      
      ! Disjunctive pronouns
! fminin accept pour 'luy' pour traiter les cas 'dedans', 'dessus', 'l^'...
      'luy'    $$110000110000                    NULL
      'lui'    $$100000100000                    NULL
      'elle'   $$010000010000                    NULL
      'eux'    $$000110000110                    NULL
      'elles'  $$000010000010                    NULL;

Array LanguageDescriptors table

   !  word       possible GNAs   descriptor      connected
   !             to follow:      type:           to:
   !             a     i
   !             s  p  s  p
   !             mfnmfnmfnmfn                 

      'mon'    $$100000100000    POSSESS_PK      0
      'ma'     $$010000010000    POSSESS_PK      0
      'mes'    $$000110000110    POSSESS_PK      0
      'son'    $$100000100000    POSSESS_PK      '-lui'
      'sa'     $$010000010000    POSSESS_PK      '-lui'
      'ses'    $$000110000110    POSSESS_PK      '-lui'
      'leur'   $$110000110000    POSSESS_PK      '-les'
      'leurs'  $$000110000110    POSSESS_PK      '-les' 

      'le'     $$100000100000    DEFART_PK       NULL
      'la'     $$010000010000    DEFART_PK       NULL
      'l^'     $$110000110000    DEFART_PK       NULL
      'les'    $$000110000110    DEFART_PK       NULL
      'un'     $$100000100000    INDEFART_PK     NULL
      'une'    $$010000010000    INDEFART_PK     NULL
      'des'    $$000110000110    INDEFART_PK     NULL

     'allum'  $$100000100000    light           NULL
     'allume' $$010000010000    light           NULL
     'teint'  $$100000100000    (-light)        NULL
     'teinte' $$010000010000    (-light)        NULL;

Array LanguageNumbers table
    'un' 1 'une' 1 'deux' 2 'trois' 3 'quatre' 4 'cinq' 5
    'six' 6 'sept' 7 'huit' 8 'neuf' 9 'dix' 10
    'onze' 11 'douze' 12 'treize' 13 'quatorze' 14 'quinze' 15
    'seize' 16 'dix-sept' 17 'dix-huit' 18 'dix-neuf' 19 'vingt' 20;

! ---------------------------------------------------------------------------
!   Part III.   Translation
! ---------------------------------------------------------------------------

! D'aprs la traduction espagnole :
! La fonction suivante enlve les accents des mots qui n'ont pu tre
! interprets. De cette manire, le joueur peut utiliser les accents ou non.
! Pour cela le jeu doit dfinir les mots sans accent, par exemple :
! object sillon "trousseau de cls"
! with name 'trousseau' 'cles'
!
! Si le joueur met : "examine cles", le mot est compris directement.
! S'il met "examine cls", le mot n'est pas compris, de sorte que 
! l'accent est enlev et l'analyse grammaticale (parsing) reffectue.
!
! Ce cas n'est pas spcialement important, puisque le programeur
! peut toujours dfinir 'cles' et 'cls', les deux comme noms de
! l'objet.

! Pero el asunto es ms importante para el caso de los
! verbos, ya que si el jugador teclea "cgelo" este es separado en
! "cge" y "-lo" y el verbo "cge" (con acento) no sera
! comprendido.

! L'appel de cette fonction peut tre dsactiv avec la commande de
! deboguage "accents oui" de sorte que les accents que frappe le joueur
! ne soient pas limins (avec proposition d'puration).

global enleveaccents=1;

[ enleve_accents x i word at len;
    if (parser_trace>=7) ! imprimer le buffer reu
    {
      	print "^[ enleve_accents :  ";
      	print "Buffer reu : |";
      	for(i=2:i<2+buffer->1:i++) print (char) buffer->i;
      	print "|^  ";
    } 
    for (x=0:x<parse->1:x++) ! pour chaque mot
    {
	word = parse-->(x*2 + 1);
	at = parse->(x*4 + 5);
	len = parse->(x*4 + 4);
	if (word==0) ! non compris
	{
	    if (parser_trace>=7)
	    {
		print "NON COMPRIS : |";
	    	for (i=at:i<at+len:i++) print (char) buffer->i;
	    	print "|^";
	    }
	    for (i=at:i<at+len:i++)
		if (buffer->i=='') buffer->i='e';
	    else if(buffer->i=='') buffer->i='a';
	    else if(buffer->i=='') buffer->i='e';
	    else if(buffer->i=='') buffer->i='u';
	    else if(buffer->i=='') buffer->i='a';
	    else if(buffer->i=='') buffer->i='e';
	    else if(buffer->i=='') buffer->i='i';
	    else if(buffer->i=='') buffer->i='o';
	    else if(buffer->i=='') buffer->i='u';
	    else if(buffer->i=='') buffer->i='a';
	    else if(buffer->i=='') buffer->i='e';
	    else if(buffer->i=='') buffer->i='i';
	    else if(buffer->i=='') buffer->i='o';
	    else if(buffer->i=='') buffer->i='u';
	    else if(buffer->i=='') buffer->i='c';
    		@tokenise buffer parse; 
	    }
	}

    if (parser_trace>=7)
    {
	print "Buffer sans accents : |";
    	for (i=2:i<2+buffer->1:i++)
	    print (char) buffer->i;
    	print "|^";
    }
];

[ LanguageToInformese ;
    FrenchToInformese(buffer, parse);
];

[ FrenchToInformese buffer parse i word wordsuiv at;

    @tokenise buffer parse;
    if (parser_trace>=7) ! imprimer le buffer reu
    {
       print "^[ LanguageToInformese:  ";
       print "Buffer reu : |";
       for(i=2:i<2+buffer->1:i++)
           print (char) buffer->i;
       print "|^  ";
    }

     for (i=0:i<parse->1:i++)
     {
         word = parse-->(i*2 + 1);
         if (i+1==parse->1) wordsuiv = THEN1__WD;
         else wordsuiv = parse-->((i+1)*2 + 1);
         at = parse->(i*4 + 5);
         if ((word == 'la' or 'le')
             && (wordsuiv == THEN1__WD or THEN2__WD or THEN3__WD))
         {   LTI_Insert(at, '-');
             @tokenise buffer parse;
             i = 0; continue;
         }
         if (word == 'dessus')
         {   LTI_Insert(at, ' ');
             buffer->at     = 's';
             buffer->(at+1) = 'u';
             buffer->(at+2) = 'r';
             buffer->(at+3) = ' ';
             buffer->(at+4) = 'l';
             buffer->(at+5) = 'u';
             buffer->(at+6) = 'y';
             @tokenise buffer parse;
             i = 0; continue;
         }
         if (word == 'dedans')
         {   LTI_Insert(at, ' ');
             LTI_Insert(at, ' ');
             buffer->at     = 'd';
             buffer->(at+1) = 'a';
             buffer->(at+2) = 'n';
             buffer->(at+3) = 's';
             buffer->(at+4) = ' ';
             buffer->(at+5) = 'l';
             buffer->(at+6) = 'u';
             buffer->(at+7) = 'y';
             @tokenise buffer parse;
             i = 0; continue;
         }

	 ! enleve le '-' pour viter l'ajout d'un espace
         if ((word == 'nord-est') || (word == 'nord-ouest'))
         {
             buffer->at     = ' ';
             buffer->(at+1) = 'n';
             buffer->(at+2) = 'o';
             buffer->(at+3) = 'r';
             buffer->(at+4) = 'd';
             @tokenise buffer parse;
             i = 0; continue;
         }
         if ((word == 'sud-est') || (word == 'sud-ouest'))
         {
             buffer->at     = ' ';
             buffer->(at+1) = 's';
             buffer->(at+2) = 'u';
             buffer->(at+3) = 'd';
             @tokenise buffer parse;
             i = 0; continue;
         }
     }

    !  Insertion d'un espace avant chaque tiret et aprs chaque apostrophe 
    for (i=2:i<2+buffer->1:i++)
    {   if (buffer->i == '-') LTI_Insert(i++, ' ');
        if (buffer->i == ''') LTI_Insert(i+1, ' ');
    }
    @tokenise buffer parse; 

        ! Transformation de phrases commenant par un pronom
        ! Ex : "le regarder' devient 'regarder lui'
      word = parse-->(1);
        if (word == 'le')
        {
        buffer->(parse->5) = ' ';
        buffer->(parse->5+1) = ' ';
        LTI_Insert(parse->9+parse->8, ' ');
        LTI_Insert(parse->9+parse->8+1, 'l');
        LTI_Insert(parse->9+parse->8+2, 'u');
        LTI_Insert(parse->9+parse->8+3, 'i');
        }
        if (word == 'l^')
        {
        buffer->(parse->5) = ' ';
        buffer->(parse->5+1) = ' ';
        LTI_Insert(parse->9+parse->8, ' ');
        LTI_Insert(parse->9+parse->8+1, 'l');
        LTI_Insert(parse->9+parse->8+2, 'u');
        LTI_Insert(parse->9+parse->8+3, 'y');
        }
        if (word == 'la')
        {
        buffer->(parse->5) = ' ';
        buffer->(parse->5+1) = ' ';
        LTI_Insert(parse->9+parse->8, ' ');
        LTI_Insert(parse->9+parse->8+1, 'e');
        LTI_Insert(parse->9+parse->8+2, 'l');
        LTI_Insert(parse->9+parse->8+3, 'l');
        LTI_Insert(parse->9+parse->8+4, 'e');
        }
        if (word == 'les')
        {
        buffer->(parse->5) = ' ';
        buffer->(parse->5+1) = ' ';
        buffer->(parse->5+2) = ' ';
        LTI_Insert(parse->9+parse->8, ' ');
        LTI_Insert(parse->9+parse->8+1, 'e');
        LTI_Insert(parse->9+parse->8+2, 'u');
        LTI_Insert(parse->9+parse->8+3, 'x');
        }
!        if (word == 'me')
!        {
!        buffer->(parse->5) = ' ';
!        buffer->(parse->5+1) = ' ';
!        LTI_Insert(parse->9+parse->8, ' ');
!        LTI_Insert(parse->9+parse->8+1, 'm');
!        LTI_Insert(parse->9+parse->8+2, 'o');
!        LTI_Insert(parse->9+parse->8+3, 'i');
!        }
!        if (word == 'se')
!        {
!        buffer->(parse->5) = ' ';
!        buffer->(parse->5+1) = ' ';
!        LTI_Insert(parse->9+parse->8, ' ');
!        LTI_Insert(parse->9+parse->8+1, 'm');
!        LTI_Insert(parse->9+parse->8+2, 'o');
!        LTI_Insert(parse->9+parse->8+3, 'i');
!        }
!        if (buffer->2 == 'y')
!        if (buffer->3 == ' ')
!        buffer->(parse->5) = ' ';
	@tokenise buffer parse;
                                  
    if (enleveaccents) enleve_accents();
        
    ! Como paso final, quitamos las palabras que aparezcan dos veces
    ! seguidas. Esto puede ocurrir si el jugador teclea un comando
    ! incompleto, como "MIRA HACIA", y el parser le pregunta "Hacia
    ! donde quieres mirar?" y el jugador responde "HACIA EL NORTE". En
    ! este caso se construira la orden concatenada: "MIRA HACIA HACIA
    ! EL NORTE".
    !*! Ceci doit avoir parfois des effets indsirables (restreindre  des
      ! prpositions bien prcises ?)
      ! de plus, deux prpositions quivalentes mais distinctes ne seront
      ! pas limines (lesquelles ?)
    ElimineDoublons(buffer, parse);

    if (parser_trace>=7)
    {
       print "Buffer traduit en informese : ^|";
       for (i=2:i<2+buffer->1:i++)
           print (char) buffer->i;
       print "|^";
    }
                                                
];

[ ElimineDoublons buffer parse
    word at len x i siguiente cambiado;

    @tokenise buffer parse;
    if (parser_trace>=8) !imprimer le buffer reu
    {
        print "^[ ElimineDoublons:  ";
        print "Buffer reu: |";
        for(i=2:i<2+buffer->1:i++) print (char) buffer->i;
        print "| (", parse->1, " palabras)^";
    }
    for (x=0:x<(parse->1)-1:x++) !para cada palabra
    {
        word = parse-->(x*2 + 1);
        siguiente = parse-->((x+1)*2 +1);
        at = parse->(x*4 + 5);
        len = parse->(x*4 + 4);
        if ((word==siguiente) && (word~=0))
        {
            if (parser_trace>=8) print "Doublons rencontrs ! :
                !",(address) word, "=", (address) siguiente, ".^";

            for (i=at:i<at+len:i++) buffer->i=' ';
            cambiado=1;
        }
    }
    if (cambiado)
        @tokenise buffer parse;
];
 
[ LanguageIsVerb buf pars pos
    i;

    pos=0;

    if (parser_trace>=7) ! imprimer le buffer reu
    {
          print "^[ LanguageIsVerb:  ";
          print "Buffer reu : |";
          for(i=2:i<2+buf->1:i++) print (char) buf->i;
          print "|^  ";
    }
    FrenchToInformese(buf, pars);
    i=UnknownVerb(pars-->(pos*2+1));
    if (i==0) return (pars-->(pos*2+1)); else return i;
];


! ---------------------------------------------------------------------------
!   Part IV.   Printing
! ---------------------------------------------------------------------------

Constant LanguageAnimateGender   = male;
Constant LanguageInanimateGender = male;

Constant LanguageContractionForms = 2;     ! French has two:
                                           ! 0 = starting with a consonant
                                           ! 1 = starting with a vowel
                                           !     or mute h

[ LanguageContraction text;
  if (text->0 == 'a' or 'e' or '' or '' or 'i' or 'o' or 'u' or 'h'
                 or 'A' or 'E' or 'I' or 'O' or 'U' or 'H') return 1;
  return 0;
];

Array LanguageArticles -->

 !   Contraction form 0:     Contraction form 1:
 !   Cdef   Def    Indef     Cdef   Def    Indef

     "Le "  "le "  "un "     "L'"   "l'"   "un "          ! 0: masc sing
     "La "  "la "  "une "    "L'"   "l'"   "une "         ! 1: fem sing
     "Les " "les " "des "    "Les " "les " "des ";        ! 2: plural

                   !             a           i
                   !             s     p     s     p
                   !             m f n m f n m f n m f n                 

Array LanguageGNAsToArticles --> 0 1 0 2 2 2 0 1 0 2 2 2;

[ LanguageDirection d;
   switch(d)
   {   n_to: print "nord";
       s_to: print "sud";
       e_to: print "est";
       w_to: print "ouest";
       ne_to: print "nord-est";
       nw_to: print "nord-ouest";
       se_to: print "sud-est";
       sw_to: print "sud-ouest";
       u_to: print "haut";
       d_to: print "bas";
       in_to: print "dedans";
       out_to: print "dehors";
       default: return RunTimeError(9,d);
   }
];

[ LanguageNumber n f;
  if (n==0)    { print "zro"; rfalse; }
  if (n<0)     { print "moins "; n=-n; }
  if (n>=1000) { print (LanguageNumber) n/1000, " mille"; n=n%1000; f=1; }
  if (n>=100)  { if (f==1) print ", ";
                 print (LanguageNumber) n/100, " cent"; n=n%100; f=1; }
  if (n==0) rfalse;
  switch(n)
  {   1:  print "un";
      2:  print "deux";
      3:  print "trois";
      4:  print "quatre";
      5:  print "cinq";
      6:  print "six";
      7:  print "sept";
      8:  print "huit";
      9:  print "neuf";
      10: print "dix";
      11: print "onze";
      12: print "douze";
      13: print "treize";
      14: print "quatorze";
      15: print "quinze";
      16: print "seize";
      17: print "dix-sept";
      18: print "dix-huit";
      19: print "dix-neuf";
      20 to 99:
          switch(n/10)
          {  2: print "vingt";
                if (n%10 == 1) {print " et un"; return; }
             3: print "trente";
                if (n%10 == 1) {print " et un"; return; }
             4: print "quarante";
                if (n%10 == 1) {print " et un"; return; }
             5: print "cinquante";
                if (n%10 == 1) {print " et un"; return; }
             6: print "soixante";
                if (n%10 == 1) {print " et un"; return; }
             7: print "soixante";
                if (n%10 == 1) {print " et un"; return; }
                print "-"; LanguageNumber(10 + n%10); return;
             8: if (n%10 == 0) {print "quatre vingts"; return; }
                print "quatre-vingt";
             9: print "quatre-vingt-"; LanguageNumber(10+ n%10); return;
          }
          if (n%10 ~= 0)
          {     print "-"; LanguageNumber(n%10);
          }
  }
];

[ LanguageTimeOfDay hours mins;
   print hours/10, hours%10, "h", mins/10, mins%10;
];

[ LanguageVerb i;
   if (i==#n$r)        { print "regarder";              rtrue; }
   if (i==#n$a)        { print "attendre";              rtrue; }
   if (i==#n$x)        { print "examiner";           rtrue; }
   if (i==#n$i or 'inv' or 'inventaire')
                       { print "inventaire";         rtrue; }
   rfalse;
];

Constant NKEY__TX     = "S = suivant";
Constant PKEY__TX     = "P = prcdent";
Constant QKEY1__TX    = "   Q = retour";
Constant QKEY2__TX    = "Q = menu prcdent";
Constant RKEY__TX     = "ENTREE = lire sujet";

Constant NKEY1__KY    = 'S';
Constant NKEY2__KY    = 's';
Constant PKEY1__KY    = 'P';
Constant PKEY2__KY    = 'p';
Constant QKEY1__KY    = 'Q';
Constant QKEY2__KY    = 'q';

Constant SCORE__TX    = "Score : ";
Constant MOVES__TX    = "Tours : ";
Constant TIME__TX     = "Heure : ";
Constant CANTGO__TX   = "Vous ne pouvez pas aller dans cette direction.";
Constant FORMER__TX   = "votre ancien vous";
Constant YOURSELF__TX = "vous-mme";
Constant DARKNESS__TX = "L'obscurit";

Constant THOSET__TX   = "ces choses-l";
Constant THAT__TX     = "a";
Constant OR__TX       = " ou ";
Constant NOTHING__TX  = "rien";
Constant IS__TX       = "est ";   ! utiliss par WriteListFrom
Constant ARE__TX      = "sont ";  ! 
Constant IS2__TX      = "";  ! dans/sur lequel " est"  => contenant/supportant
Constant ARE2__TX     = "";  ! dans/sur lequel " sont" => contenant/supportant
Constant AND__TX      = " et ";
Constant WHOM__TX     = "";  ! dans/sur "lequel " est  => contenant/supportant
Constant WHICH__TX    = "";  ! dans/sur "lequel " est  => contenant/supportant

![ ThatorThose obj;   ! ex : vous n'allez pas manger a (accusatif) (utile ?)
!  print "a";
!];
[ ItorThem obj; ! ex : avant de pouvoir vous/le/la/les poser... (accusatif ?)
  if (obj == player) { print "vous"; return; }
  if (obj has pluralname)  { print "les"; return;}
  if (obj has female) { print "la"; return; }
  else { print "le"; return; }
];
[ IsorAre obj;
  if (obj has pluralname || obj == player) print "sont"; else print "est";
];
[ CThatorThose obj;   ! il/ils/elle/elles semble(nt) ouvert(e) (nominatif)
  ! if (obj == player) { print "Vous"; return; } !* utile ?
  if (obj has pluralname) {
    if (obj has female) {print "Elles"; return; }
    else { print "Ils"; return; }
  }
  if (obj has female) { print "Elle"; return; }
  else { print "Il"; return; }
];
[ CTheyreorThats obj;
  if (obj == player) { print "Vous tes"; return; }
  if (obj has pluralname) {
     if (obj has female) { print "Elles sont"; return; }
     else { print "Ils sont"; return; }
  }
  if (obj has female) { print "Elle est"; return; }
  else { print "Il est"; return; }
];

! Quelques fonctions additionnelles...
[ es obj; ! ex: ferm(es), ouvert(es)
  if (obj has female) print "e";
  if (obj has pluralname) print "s";
  !* attention : pris, prise, pris, prises
];
[ s obj; ! ex: vide(s)
  if (obj has pluralname) print "s";
];
[ DeDuDes obj; ! ex : descendre du train            !*!  bien valider
  if (obj == player) { print "de vous"; return; }
  if (obj has pluralname)  { print "des ", (name) obj; return;}
  if (obj has female or proper) {
      print "de ", (the) obj; return;
  } else {
      if (obj->article=='l^') !*! ce test ne marche sans doute pas
      			      !*! (incorrect et pb de l'article indfini
      			      !*!     ex : un oiseau => de l'oiseau)
          {print "de ", (the) obj; return;}
      else {print "du ", (name) obj; return;}
  }
];
[ nt obj; ! ex: semble(nt)
  if (obj has pluralname) print "nt";
  !*! attention :  parat, paraissent (etc)
];
[ IsorAreNot obj;
  if (obj has pluralname || obj == player) print "ne sont pas";
                                      else print "n'est pas";
];

[ LanguageLM n x1;
  Prompt:  print "^>";
  Miscellany:
           switch(n)
           {   1: "(affichage des seize premiers)^";
               2: "Rien  faire !";
               3: print " Vous tes mort ";
               4: print " Vous avez gagn ";
               5: print "^Voulez-vous RECOMMENCER,
                          CHARGER une partie sauvegarde";
                  #IFDEF DEATH_MENTION_UNDO;
                  print ", ANNULER votre dernire action";
                  #ENDIF;
                  if (TASKS_PROVIDED==0)
                      print ", obtenir le score dtaill pour cette partie (FULLSCORE)";
                  if (deadflag==2 && AMUSING_PROVIDED==0)
                      print ", lire quelques suggestions amusantes (AMUSING)";
                  " ou quitter (QUIT) ?";
               6: "[Votre interprteur ne permet pas d' ~annuler~. Dsol !]";
               7: "~ANNULER~ a chou.  [Tous les interprteurs ne le permettent pas.]";
               8: "Faites un choix parmi les propositions ci-dessus.";
               9: "^Vous tes  prsent plong dans l'obscurit !";
              10: "Je vous demande pardon ?";
              11: "[Vous ne pouvez pas annuler alors que rien n'a encore t fait !]";
              12: "[Impossible d'annuler deux fois de suite. Dsol !]";
              13: "[Action prcdente annule.]";
              14: "Dsol, impossible de corriger.";
              15: "N'y pensez mme pas."; !*! "Think nothing of it."; !*!
              16: "~Oops~ ne peut corriger qu'un seul mot.";
              17: "Il fait noir, et vous ne pouvez rien voir.";
              18: print "vous-mme";
              19: "Aussi beau que d'habitude.";           
              20: "Pour rpter une commande comme ~grenouille, saute~, dtes seulement
                   ~encore~, et pas ~grenouille, encore~.";
              21: "Vous pouvez difficilement rpter cela.";
              22: "Vous ne pouvez pas commencer par une virgule.";
              23: "Vous semblez vouloir parler  quelqu'un, mais je ne vois pas  qui.";
              24: "Vous ne pouvez pas discuter avec ", (the) x1, ".";
                  ! "parler " serait mieux mais dlicat (ex:  l'oiseau)
              25: "Pour parler  quelqu'un, essayez ~quelqu'un, bonjour~ ou quelque chose dans le genre.";
              26: "(vous prenez d'abord ", (the) not_holding, ")";
              27: "Je ne comprends pas cette phrase.";
              28: print "Je n'ai compris que : ";
              29: "Je n'ai pas compris ce nombre.";
              30: "Vous ne pouvez voir une telle chose.";
              31: "Vous semblez en avoir dit trop peu !";
              32: "Vous ne l'avez pas dans vos mains !";
              33: "Vous ne pouvez pas employer le mot ~tout~ avec ce verbe.";
              34: "Vous ne pouvez utiliser le mot ~tout~ qu'une fois par ligne."; !*!
              35: "Je ne suis pas sr de ce  quoi ~", (address) pronoun_word,
                  "~ se rfre.";
              36: "Vous avez exclu quelque chose qui n'tait de toute faon pas compris dans la liste !";
              37: "Vous ne pouvez faire cela qu' une chose anime.";
              38: "Je ne connais pas ce verbe.";
              39: "Ce n'est pas une chose  laquelle vous devrez vous rfrer
                   au cours du jeu.";
              40: "Vous ne pouvez voir ~", (address) pronoun_word,
                  "~ (", (the) pronoun_obj, ") pour l'instant.";
              41: "Impossible de comprendre la fin de la phrase.";
              42: if (x1==0) print "Aucun de disponible.";
                  else print "Il en reste seulement ", (number) x1, ".";
              43: "Rien  faire !";
              44: "Rien n'est disponible !";
              45: print "Prcisez : "; !*!
              46: print "Prcisez : "; !*!
              47: "Dsol, vous pouvez seulement avoir un objet ici. Lequel voulez-vous exactement ?";
!              48: print "Pouvez-vous prciser  qui ? (tapez le nom seul, sans la prposition '')^";
              48: print "Pouvez-vous prciser ?^"; !*!
!              49: print "Pouvez-vous prciser avec quoi ? (tapez le nom seul, sans la prposition 'avec')^";
              49: print "Pouvez-vous prciser ?^"; !*!
              50: print "Votre score vient ";
                  if (x1 > 0) print "d'augmenter"; else { x1 = -x1; print "de diminuer"; }
                  print " de ", (number) x1, " point";
                  if (x1 > 1) print "s";
              51: "(Comme quelque chose de dramatique vient de se produire,
                   votre liste de commandes a t raccourcie.)";
              52: "^Tapez un nombre entre 1 et ", x1,
                  ", 0 pour rafficher ou appuyez sur ENTREE.";
              53: "^[Appuyez sur ESPACE pour continuer.]"; !*! SVP, et pas forcment pour continuer
           }

  ListMiscellany:
           switch(n)
           {   1: print " (allum",(es) x1,")";
               2: print " (qui ", (isorare) x1, " ferm",(es) x1,")";
               3: print " (ferm",(es) x1," et allum",(es) x1,")";
               4: print " (qui ", (isorare) x1, " vide",(s) x1,")";
               5: print " (vide",(s) x1," et allum",(es) x1,")";
               6: print " (qui ", (isorare) x1, " ferm",(es) x1," et vide",(s) x1,")";
               7: print " (ferm",(es) x1,", vide",(s) x1," et allum",(es) x1,")";
               8: print " (allum",(es) x1," et port",(es) x1;
               9: print " (allum",(es) x1;
              10: print " (port",(es) x1;
              11: print " (qui ", (isorare) x1, " ";
              12: print "ouvert",(es) x1;
              13: print "ouvert",(es) x1," mais vide",(s) x1;
              14: print "ferm",(es) x1;
              15: print "ferm",(es) x1," et verrouill",(es) x1;
              16: print " et vide",(s) x1;
              17: print " (qui ", (isorare) x1, " vide",(s) x1,")";
              18: print " contenant ";
              19: print " (supportant "; ! " (sur ";
              20: print " supportant ";  ! " sur "; 
              21: print " (contenant ";  ! " (dans ";
              22: print " contenant ";   ! " dans ";
           }

  Pronouns: switch(n)
           {   1: print "En ce moment, ";
               2: print "signifie ";
               3: print "est enlev";
               4: "aucun pronom n'est connu du jeu.";
           }
  Order:          print (The) x1;
                  if (x1 has pluralname) print " ont"; else print " a";
                  " mieux  faire.";
  Quit:    switch(n)
           {   1: print "Rpondez par oui ou par non, je vous prie.";
               2: print "Etes-vous sr de vouloir quitter ? ";
           }
  Restart: switch(n)
           {   1: print "Etes-vous sr de vouloir recommencer ? ";
               2: "Rat.";
           }
  Restore: switch(n)
           {   1: "Echec du chargement.";
               2: "Ok.";
           }
  Save:    switch(n)
           {   1: "La sauvegarde a chou.";
               2: "Ok.";
           }
  Verify:  switch(n)
           {   1: "Le fichier semble intact.";
               2: "Le fichier est certainement corrompu !";
           }
  ScriptOn: switch(n)
           {   1: "Transcription dj en cours.";
               2: "Dbut d'une transcription de...";
               3: "Impossible de commencer la transcription.";
           }
  ScriptOff: switch(n)
           {   1: "Aucune transcription en cours.";
               2: "^Fin de transcription.";
               3: "Impossible de terminer la transcription.";
           }
  NotifyOn:       "Notification du score active.";
  NotifyOff:      "Notification du score dsactive.";
  Places:         print "Vous avez visit : ";
  Objects: switch(n)
           {   1: "Objets ayant t ports :^";
               2: "Aucun.";
               3: print "   (sur le corps)";
               4: print "   (dans l'inventaire)";
               5: print "   (abandonn",(es) x1,")";
               6: print "   (", (name) x1, ")";
               7: print "   (dans ", (the) x1, ")";
               8: print "   (dans ", (the) x1, ")";
               9: print "   (sur ", (the) x1, ")";
              10: print "   (perdu",(es) x1,")";
           }
  Score:          if (deadflag) print "Dans ce jeu vous avez obtenu ";
                  else print "Vous avez jusqu' prsent obtenu ";
                  print score, " sur un score possible de ", MAX_SCORE,
                  ", en ", turns, " tour";
                  if (turns>1) print "s"; return;
  FullScore: switch(n)
           {   1: if (deadflag) print "Le score tait ";
                  else          print "Le score est ";
                  "compos comme suit :^";
               2: "trouver divers objets";
               3: "visiter diffrents endroits";
               4: print "total (sur ", MAX_SCORE; ")";
           }
  Inv:     switch(n)
           {   1: "Vous n'avez rien.";
               2: print "Vous avez";
           }
  Take:    switch(n)
           {   1: "Ok.";
               2: "Vous vous possdez vous-mme.";
               3: "Cela ne semble pas tre une bonne ide.";
               4: print "Vous devez d'abord ";
                  if (x1 has supporter) print "descendre "; else print "sortir ";
                  print_ret (dedudes) x1, ".";
               5: "Vous l'avez dj.";
               6: if (noun has pluralname) print "Cela semble ";
                  else print "Cela semble ";
                  "appartenir  ", (the) x1, ".";
               7: if (noun has pluralname) print "Cela semble ";
                  else print "Cela semble ";
                  "faire partie ", (dedudes) x1, ".";
               8: print_ret (Cthatorthose) x1, " ", (isorarenot) x1,
                  " disponible", (s) x1, ".";
               9: print_ret (The) x1, " ", (isorarenot) x1, " ouvert",(es) x1,".";
              10: "Trop difficile  transporter.";
              11: "C'est fix sur place.";
              12: "Vous transportez dj trop d'objets.";
              13: "(vous mettez ", (the) x1, " dans ", (the) SACK_OBJECT,
                  " pour faire de la place)";
           }
  Drop:    switch(n)
           {   1: if (x1 has pluralname) print (The) x1, " sont ";
                  else print (The) x1, " est ";
                  "dj ici.";
               2: "Vous n'avez pas a.";
               3: "(vous prenez d'abord ", (the) x1, ")";
               4: "Ok.";
           }
  Remove:  switch(n)
           {   1: if (x1 has pluralname)
		      print "Ils sont malheureusement ferms."; !*! elle(s)
		      else print "Il est malheureusement ferm."; !*!
               2: if (x1 has pluralname)
                      print "Mais ils ne sont pas";
                  else print "Mais ce n'est pas";
                  " ici maintenant.";
               3: "Ok.";
           }
  PutOn:   switch(n)
           {   1: "Vous devez avoir en main ", (the) x1,
                  " avant de pouvoir ", (itorthem) x1,
                  " mettre sur quelque chose d'autre.";
               2: "Vous ne pouvez pas poser un objet sur lui-mme.";
               3: "Poser des objets sur ", (the) x1, " ne mnerait  rien.";
               4: "Vous manquez de dextrit.";
               5: "(", (itorthem) x1, " prenant d'abord)^";
               6: "Il n'y a plus assez de place sur ", (the) x1, ".";
               7: "C'est fait.";
               8: "Vous mettez ", (the) x1, " sur ", (the) second, ".";
           }
  Insert:  switch(n)
           {   1: "Vous devez avoir en main ", (the) x1,
                  " avant de pouvoir ", (itorthem) x1,
                  " mettre dans autre chose.";
               2: print_ret (Cthatorthose) x1, " ne peut pas contenir d'objet.";
               3: print_ret (The) x1, " ", (isorare) x1, " ferm",(es) x1,".";
               4: "Vous avez besoin de ", (itorthem) x1, " prendre d'abord.";
               5: "Vous ne pouvez pas mettre un objet  l'intrieur de lui-mme.";
               6: "(", (itorthem) x1, " prenant d'abord)^";
               7: "Il n'y a plus de place dans ", (the) x1, ".";
               8: "Fait.";
               9: "Vous mettez ", (the) x1, " dans ", (the) second, ".";
           }
  EmptyT:  switch(n)
           {   1: print_ret (The) x1, " ne peut rien contenir.";
               2: print_ret (The) x1, " ", (isorare) x1, " ferm",(es) x1,".";
               3: print_ret (The) x1, " ", (isorare) x1, " dj vide",(s) x1,".";
               4: "Ceci ne viderait rien.";
           }
  Give:    switch(n)
           {   1: "Vous n'avez pas en main ", (the) x1, ".";
               2: "Vous jonglez avec ", (the) x1,
                  " pendant un moment, mais vous n'arrivez pas  grand chose.";
               3: print (The) x1;
                  if (x1 has pluralname)
	             print " n'ont pas l'air intress";
                  else print " n'a pas l'air intress";
                  ".";
           }
  Show:    switch(n)
           {   1: "Vous n'avez pas ", (the) x1, ".";
               2: print_ret (The) x1, " ", (isorare) x1, " peu impressionn",(es) x1,".";
           }
  Enter:   switch(n)
           {   1: print "Mais vous tes dj ";
                  if (x1 has supporter) print "sur "; else print "dans ";
                  print_ret (the) x1, ".";
               2: "Impossible."; !*!*!
               3: "Vous ne pouvez entrer dans ", (the) x1, " ferm",(es) x1,".";
               4: print "Vous ne pouvez pas ";                  
                  if (x1 has supporter) print "monter sur";
                                   else print "entrer dans";
                  " cette chose si elle n'est pas pose."; 
                               ! sur pieds, non encastr (freestanding)
               5: print "Vous ";
                  if (x1 has supporter) print "montez sur "; else print "entrez dans ";
                  print_ret (the) x1, ".";
               6: print "(";
                  if (x1 has supporter) print "descendant "; else print "sortant ";
                  print (the) x1; ")";
               7: if (x1 has supporter) "(montant sur ", (the) x1, ")^";
                  if (x1 has container) "(entrant dans ", (the) x1, ")^";
                  "(entering ", (the) x1, ")^";
           }
  GetOff:         "Mais vous n'tes pas sur ", (the) x1, " en ce moment.";
  Exit:    switch(n)
           {   1: "Sortir d'o ?!";
               2: print "Vous ne pouvez pas sortir ";
                  print_ret (dedudes) x1, " ferm", (es) x1, ".";
               3: print "Vous ";
                  if (x1 has supporter) print "descendez "; else print "sortez ";
                  print_ret (dedudes) x1, ".";
           }
  VagueGo:       "O a ?";

  Go:      switch(n)
           {   1: print "Vous devez d'abord ";
                  if (x1 has supporter) print "descendre "; else print "sortir ";
                  print_ret (dedudes) x1, ".";
               2: "Vous ne pouvez pas aller par l.";
               3: "Vous tes incapable de gravir ", (the) x1, ".";
               4: "Vous tes incapable de descendre par ", (the) x1, ".";
               5: "Vous ne pouvez pas, puisque ", (the) x1, " ", (isorare) x1,
                  " sur votre chemin.";
               6: print "Vous ne pouvez pas, puisque ", (the) x1;
                  if (x1 has pluralname) " ne mnent nulle part.";
                  " ne mne nulle part.";
           }

  LMode1:         " est pass en mode description normale ; seuls les lieux 
                   visits pour la premire fois sont dcrits en dtail.";
  LMode2:         " est pass en mode description longue ; tous les lieux,
                   mme dj visits, sont dcrits en dtail.";
  LMode3:         " est pass en mode description courte ; tous les lieux,
                   mme non visits, sont dcrits brivement.";

  Look:    switch(n)
           {   1: print " (sur ", (the) x1, ")";
               2: print " (dans ", (the) x1, ")";
               3: print " (comme "; @print_obj x1; print ")";
               4: print "^Sur ", (the) x1, ", ";
                  WriteListFrom(child(x1),
                      ENGLISH_BIT + RECURSE_BIT + PARTINV_BIT
                      + TERSE_BIT + CONCEAL_BIT);
                  ".";
         default: if (x1~=location)
                  {   if (x1 has supporter) print "^Sur "; else print "^Dans ";
                      print (the) x1, " vous";
                  }
                  else print "^Vous";
                  print " pouvez voir ";
                  if (n==5) print "aussi ";
                  WriteListFrom(child(x1),
                      ENGLISH_BIT + WORKFLAG_BIT + RECURSE_BIT
                      + PARTINV_BIT + TERSE_BIT + CONCEAL_BIT);
                  ".";
           }

  Examine: switch(n)
           {   1: "Vous ne pouvez rien voir.";
               2: "Rien de particulier concernant ", (the) x1, ".";
               3: print (The) x1, " ", (isorare) x1, " actuellement ";
                  if (x1 has on) "allum",(es) x1,"."; else "teint",(es) x1,".";
           }
  LookUnder: switch(n)
           {   1: "Mais il fait noir !";
               2: "Vous ne trouvez rien d'intressant.";
           }

  Search:  switch(n)
           {   1: "Mais il fait noir !";
               2: "Il n'y a rien sur ", (the) x1, ".";
               3: print "Sur ", (the) x1, ", vous voyez "; 
                  WriteListFrom(child(x1),
                      TERSE_BIT + ENGLISH_BIT + CONCEAL_BIT);
                  ".";
               4: "Vous ne trouvez rien d'intressant.";
               5: "Vous ne pouvez pas voir  l'intrieur, puisque ", (the) x1, " ",
                  (isorare) x1, " ferm",(es) x1,".";
               6: print_ret (The) x1, " ", (isorare) x1, " vide",(s) x1,".";
               7: print (The) x1;
                  if (x1 has pluralname) print " contiennent ";
                  else print " contient ";
                  WriteListFrom(child(x1),
                      TERSE_BIT + ENGLISH_BIT + CONCEAL_BIT);
                  ".";
           }

  Unlock:  switch(n)
           {   1: "Vous ne pouvez pas dverrouiller cela.";
               2: print_ret (ctheyreorthats) x1,
                  " dj dverrouill", (es) x1, ".";
               3: "Cela ne rentre pas dans la serrure.";
               4: "Vous dverrouillez ", (the) x1, ".";
           }
  Lock:    switch(n)
           {   1: "Vous ne pouvez pas verrouiller cela.";
               2: print_ret (ctheyreorthats) x1, " verrouill en ce moment.";
               3: "Vous devez fermer ", (the) x1, " d'abord.";
               4: "Cela ne rentre pas dans la serrure.";
               5: "Vous verrouillez ", (the) x1, ".";
           }

  SwitchOn: switch(n)
           {   1: "Vous ne pouvez pas allumer cela.";
               2: print_ret (ctheyreorthats) x1,
                  " dj allum",(es) x1,".";
               3: "Vous allumez ", (the) x1, ".";
           }
  SwitchOff: switch(n)
           {   1: "Vous ne pouvez pas allumer ou teindre cela.";
               2: print_ret (ctheyreorthats) x1,
                  " dj teint",(es) x1,".";
               3: "Vous teignez ", (the) x1, ".";
           }

  Open:    switch(n)
           {   1: "Vous ne pouvez pas ouvrir cela.";
               2: print_ret (cthatorthose) x1," semble",(nt) x1,
                  " tre ferm",(es) x1,"  cl.";
               3: print (ctheyreorthats) x1, " dj ouvert";
                  if (x1 has female) "e.";
                  ".";
               4: print "Vous ouvrez ", (the) x1, ", rvlant ";
                  if (WriteListFrom(child(x1),
                      ENGLISH_BIT + TERSE_BIT + CONCEAL_BIT)==0) "rien du tout.";
                  ".";
               5: "Vous ouvrez ", (the) x1, ".";
           }

  Close:   switch(n)
           {   1: "Vous ne pouvez pas fermer cela.";
               2: print (ctheyreorthats) x1, " dj ferm";
                  if (x1 has female) "e.";
                  ".";
               3: "Vous fermez ", (the) x1, ".";
           }
  Disrobe: switch(n)
           {   1: "Vous ne ", (itorthem) x1, " portez pas.";
               2: "Vous enlevez ", (the) x1, ".";
           }
  Wear:    switch(n)
           {   1: "Vous ne pouvez pas porter cela !";
               2: "Vous n'avez pas cela !";
               3: "Vous ", (itorthem) x1, " portez dj !";
               4: "Vous mettez ", (the) x1, ".";
           }
  Eat:     switch(n)
           {   1: print_ret (ctheyreorthats) x1,
                  " parfaitement non-comestible.";
               2: "Vous mangez ", (the) x1, ". Pas mauvais.";
           }
  Yes, No:        "Mmmh ?";
  Burn:           "Cet acte dangereux ne mnerait pas  grand chose.";
  Pray:           "Rien de pratique ne rsulte de votre prire.";
  Wake:           "L'affreuse vrit est qu'il ne s'agit pas d'un rve.";
  WakeOther:      "Cela ne semble pas ncessaire.";
  Kiss:           "Concentrez-vous sur le jeu.";
  Think:          "Quelle bonne ide.";
  Smell:          "Vous ne sentez rien de particulier.";
  Listen:         "Vous n'entendez rien de particulier.";
  Taste:          "Vous ne remarquez rien de particulier.";
  Touch:   switch(n)
           {   1: "Tenez vos mains tranquilles !";
               2: "Vous ne sentez rien de particulier.";
               3: "Si vous pensez que a peut aider.";
           }
  Dig:            "Creuser ne mnerait  rien ici.";
  Cut:            "Allons, ", (itorthem) x1, " couper ne mnerait pas  grand chose.";
  Jump:           "Vous sautez sur place, vainement.";
  JumpOver, Tie:  "Vous n'arriverez  rien comme a.";
  Drink:          "Il n'y a rien de buvable ici.";
  Fill:           "Mais il n'y a pas d'eau  porter ici.";
  Sorry:          "Pas grave.";
  Strong:         "Les vrais aventuriers n'emploient pas un tel langage.";
  Mild:           "Assez.";
  Attack:         "La violence n'est pas une solution.";
  Swim:           "Il n'y a pas assez d'eau pour nager dedans.";
  Swing:          "Il n'y a rien de sens pour se balancer ici.";
  Blow:           "Vous ne pouvez pas utilement souffler dedans.";
  Rub:            "Vous n'arrivez  rien comme a.";
  Set:            "Non, vous ne pouvez pas ", (itorthem) x1, " rgler.";
  SetTo:          "Non, vous ne pouvez pas ", (itorthem) x1, " rgler sur rien.";
  WaveHands:      "Vous agitez vos mains, vous sentant stupide.";
  Wave:    switch(n)
           {   1: "Mais vous n'avez pas cela !";
               2: "Vous avez l'air ridicule en agitant ", (the) x1, ".";
           }
  Pull, Push, Turn:
           switch(n)
           {   1: "C'est fix sur place.";
               2: "Vous en tes incapable.";
               3: "Rien d'vident ne se produit.";
               4: "Cela serait moins que courtois.";
           }
  PushDir: switch(n)
           {   1: "Vous ne pouvez donc rien imaginer de mieux ?";
               2: "Ce n'est pas une direction.";
               3: "Vous ne pouvez pas dans cette direction.";
           }
  Squeeze: switch(n)
           {   1: "Surveillez vos mains.";
               2: "Vous n'arrivez  rien ainsi.";
           }
  ThrowAt: switch(n)
           {   1: "Futile.";
               2: "Vous hsitez au moment crucial.";
           }
  Tell:    switch(n)
           {   1: "Vous discutez avec vous mme pendant un bon moment...";
               2: "Pas de raction.";
           }
  Answer, Ask:    "Pas de rponse.";
  Buy:            "Il n'y a rien  vendre, ici.";
  Sing:           "Vouz chantez abominablement faux.";
  Climb:          "Je ne pense pas que l'on puisse arriver  grand chose de cette manire.";
  Wait:           "Le temps passe...";
  Sleep:          "Vous n'avez pas particulirement sommeil.";
  Consult:        "Vous ne trouvez rien d'intressant dans ", (the) x1, ".";
];

! ---------------------------------------------------------------------------

